%global bouncycastleJdk 18
%global bouncycastleVer 1.77

Epoch:          1
Name:           apache-sshd
Version:        2.11.0
Release:        %mkrel 2
Group:          Development/Java
Summary:        Apache SSHD

# One file has ISC licensing:
#   sshd-common/src/main/java/org/apache/sshd/common/config/keys/loader/openssh/kdf/BCrypt.java
License:        ASL 2.0 and ISC
URL:            https://mina.apache.org/sshd-project

Source0:        https://archive.apache.org/dist/mina/sshd/%{version}/apache-sshd-%{version}-src.tar.gz

# Avoid optional dep on tomcat native APR library
Patch0:         0001-Avoid-optional-dependency-on-native-tomcat-APR-libra.patch
Patch1:         apache-sshd-javadoc.patch

BuildRequires:  maven-local
BuildRequires:  mvn(junit:junit)
BuildRequires:  mvn(net.i2p.crypto:eddsa)
BuildRequires:  mvn(org.apache:apache:pom:)
BuildRequires:  mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires:  mvn(org.apache.maven:maven-archiver)
BuildRequires:  mvn(org.apache.maven.plugins:maven-antrun-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-clean-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-dependency-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-remote-resources-plugin)
BuildRequires:  mvn(org.apache.maven.surefire:surefire-junit47)
BuildRequires:  mvn(org.bouncycastle:bcpg-jdk%{bouncycastleJdk}on)
BuildRequires:  mvn(org.bouncycastle:bcpkix-jdk%{bouncycastleJdk}on)
BuildRequires:  mvn(org.codehaus.mojo:build-helper-maven-plugin)
BuildRequires:  mvn(org.codehaus.plexus:plexus-archiver)
BuildRequires:  mvn(org.slf4j:jcl-over-slf4j)
BuildRequires:  mvn(org.slf4j:slf4j-api)

BuildArch:      noarch
#ExclusiveArch:  %%{java_arches} noarch

%description
Apache SSHD is a 100% pure java library to support the SSH protocols on both
the client and server side.

%package        javadoc
Summary:        API documentation for %{name}

%description    javadoc
This package provides %{name}.

%prep
%setup -q

# Avoid optional dep on tomcat native APR library
%patch -P0 -p1
%patch -P1 -p1
rm -rf sshd-core/src/main/java/org/apache/sshd/agent/unix

# Avoid unnecessary dep on spring framework
%pom_remove_dep :spring-framework-bom
%pom_remove_dep :testcontainers-bom sshd-sftp sshd-core sshd-scp

# Build the core modules only
%pom_disable_module assembly
%pom_disable_module sshd-mina
%pom_disable_module sshd-netty
%pom_disable_module sshd-ldap
%pom_disable_module sshd-git
%pom_disable_module sshd-contrib
%pom_disable_module sshd-spring-sftp
%pom_disable_module sshd-cli
%pom_disable_module sshd-openpgp

# Disable plugins we don't need for RPM builds
%pom_remove_plugin :apache-rat-plugin
%pom_remove_plugin :gmavenplus-plugin
%pom_remove_plugin :maven-checkstyle-plugin
%pom_remove_plugin :maven-enforcer-plugin
%pom_remove_plugin :maven-pmd-plugin
%pom_remove_plugin :maven-antrun-plugin
%pom_remove_plugin :animal-sniffer-maven-plugin
%pom_remove_plugin :impsort-maven-plugin
%pom_remove_plugin :formatter-maven-plugin . sshd-core


# Suppress generation of uses clauses
%pom_xpath_inject "pom:configuration/pom:instructions" "<_nouses>true</_nouses>" .
sed "s;<bouncycastle.version>.*;<bouncycastle.version>%{bouncycastleVer}</bouncycastle.version>;g" -i pom.xml

%build
# Can't run tests, they require ch.ethz.ganymed:ganymed-ssh2
%mvn_build -f -- -Dworkspace.root.dir=$(pwd) -Dmaven.compiler.release=11

%install
%mvn_install

%files -f .mfiles
%doc CHANGES.md
%license LICENSE.txt NOTICE.txt assembly/src/main/legal/licenses/jbcrypt.txt

%files javadoc -f .mfiles-javadoc
%license LICENSE.txt NOTICE.txt assembly/src/main/legal/licenses/jbcrypt.txt


%changelog
* Tue Dec 24 2024 daviddavid <daviddavid> 1:2.11.0-2.mga10
+ Revision: 2129600
- Rebuilt for java-21-openjdk as system jdk

* Tue May 21 2024 ns80 <ns80> 1:2.11.0-1.mga10
+ Revision: 2065670
- new version 2.11.0 for java 21

* Wed Aug 03 2022 neoclust <neoclust> 1:2.8.0-1.mga9
+ Revision: 1874766
- New version 2.8.0
+ umeabot <umeabot>
- Mageia 9 Mass Rebuild

* Thu Mar 11 2021 daviddavid <daviddavid> 1:2.6.0-1.mga9
+ Revision: 1701422
- Update to latest upstream release 2.6.0

* Sat Sep 05 2020 daviddavid <daviddavid> 1:2.4.0-1.mga8
+ Revision: 1622558
- Update to latest upstream release 2.4.0
- Rebuilt for JDK-11
- Fix build against Java 11

* Sun Aug 16 2020 neoclust <neoclust> 1:2.2.0-1.mga8
+ Revision: 1614225
- New version 2.2.0

* Sat Feb 15 2020 umeabot <umeabot> 1:2.0.0-2.mga8
+ Revision: 1527629
- Mageia 8 Mass Rebuild

* Fri Jul 19 2019 daviddavid <daviddavid> 1:2.0.0-1.mga8
+ Revision: 1422702
- Revert back to 2.0.0, there are problems with 2.2.0

* Wed Dec 05 2018 daviddavid <daviddavid> 2.1.0-1.mga7
+ Revision: 1338572
- new version: 2.1.0 (sync with fc29)

* Tue Sep 18 2018 umeabot <umeabot> 0.14.0-4.mga7
+ Revision: 1260575
- Mageia 7 Mass Rebuild

* Tue Sep 18 2018 umeabot <umeabot> 0.14.0-3.mga7
+ Revision: 1260216
- Mageia 7 Mass Rebuild

* Tue Sep 18 2018 umeabot <umeabot> 0.14.0-2.mga7
+ Revision: 1259787
- Mageia 7 Mass Rebuild

* Tue Jun 21 2016 daviddavid <daviddavid> 0.14.0-1.mga6
+ Revision: 1037066
- new version: 0.14.0 (sync with fedora)
+ tv <tv>
- introduce %%license macro
- AutoReqProv: yes
+ umeabot <umeabot>
- Mageia 6 Mass Rebuild

* Fri Dec 26 2014 dmorgan <dmorgan> 0.11.0-3.mga5
+ Revision: 806169
- imported package apache-sshd

